diff a/test/hotspot/jtreg/runtime/oom/TestOOM.java b/test/hotspot/jtreg/runtime/oom/TestOOM.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/oom/TestOOM.java
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8303027
+ * @requires vm.bits == "64"
+ * @summary Test that we're failing with OOME and not with VM crash
+ * @run main/othervm -Xmx1g -XX:-UseCompressedOops TestOOM
+ */
+/*
+ * @test
+ * @bug 8303027
+ * @requires vm.bits == "32"
+ * @summary Test that we're failing with OOME and not with VM crash
+ * @run main/othervm -Xmx1g TestOOM
+ */
+public class TestOOM {
+    public static void main(String[] args) {
+        // Test that it exits with OOME and not with VM crash.
+        try {
+            LinkedInsanity previous = null;
+            while (true) {
+                previous = new LinkedInsanity(previous);
+            }
+        } catch (OutOfMemoryError e) {
+            // That's expected
+        }
+    }
+
+    private static class LinkedInsanity {
+        private final LinkedInsanity previous;
+        private final int[] padding = new int[64000];
+
+        public LinkedInsanity(LinkedInsanity previous) {
+            this.previous = previous;
+        }
+    }
+}
